<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvoidFavorSet ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAvoidFavorSet
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfAvoidFavorSet extends AbstractStructArrayBase
{
    /**
     * The AvoidFavorSet
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmAvoidFavorSet[]
     */
    public $AvoidFavorSet;
    /**
     * Constructor method for ArrayOfAvoidFavorSet
     * @uses PcmArrayOfAvoidFavorSet::setAvoidFavorSet()
     * @param \Pcm\StructType\PcmAvoidFavorSet[] $avoidFavorSet
     */
    public function __construct(array $avoidFavorSet = array())
    {
        $this
            ->setAvoidFavorSet($avoidFavorSet);
    }
    /**
     * Get AvoidFavorSet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmAvoidFavorSet[]|null
     */
    public function getAvoidFavorSet()
    {
        return isset($this->AvoidFavorSet) ? $this->AvoidFavorSet : null;
    }
    /**
     * Set AvoidFavorSet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAvoidFavorSet[] $avoidFavorSet
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavorSet
     */
    public function setAvoidFavorSet(array $avoidFavorSet = array())
    {
        foreach ($avoidFavorSet as $arrayOfAvoidFavorSetAvoidFavorSetItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvoidFavorSetAvoidFavorSetItem instanceof \Pcm\StructType\PcmAvoidFavorSet) {
                throw new \InvalidArgumentException(sprintf('The AvoidFavorSet property can only contain items of \Pcm\StructType\PcmAvoidFavorSet, "%s" given', is_object($arrayOfAvoidFavorSetAvoidFavorSetItem) ? get_class($arrayOfAvoidFavorSetAvoidFavorSetItem) : gettype($arrayOfAvoidFavorSetAvoidFavorSetItem)), __LINE__);
            }
        }
        if (is_null($avoidFavorSet) || (is_array($avoidFavorSet) && empty($avoidFavorSet))) {
            unset($this->AvoidFavorSet);
        } else {
            $this->AvoidFavorSet = $avoidFavorSet;
        }
        return $this;
    }
    /**
     * Add item to AvoidFavorSet value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAvoidFavorSet $item
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavorSet
     */
    public function addToAvoidFavorSet(\Pcm\StructType\PcmAvoidFavorSet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmAvoidFavorSet) {
            throw new \InvalidArgumentException(sprintf('The AvoidFavorSet property can only contain items of \Pcm\StructType\PcmAvoidFavorSet, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AvoidFavorSet[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmAvoidFavorSet|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmAvoidFavorSet|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmAvoidFavorSet|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmAvoidFavorSet|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmAvoidFavorSet|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AvoidFavorSet
     */
    public function getAttributeName()
    {
        return 'AvoidFavorSet';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavorSet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
