<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeoTunnelReport ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGeoTunnelReport
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfGeoTunnelReport extends AbstractStructArrayBase
{
    /**
     * The GeoTunnelReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeoTunnelReport[]
     */
    public $GeoTunnelReport;
    /**
     * Constructor method for ArrayOfGeoTunnelReport
     * @uses PcmArrayOfGeoTunnelReport::setGeoTunnelReport()
     * @param \Pcm\StructType\PcmGeoTunnelReport[] $geoTunnelReport
     */
    public function __construct(array $geoTunnelReport = array())
    {
        $this
            ->setGeoTunnelReport($geoTunnelReport);
    }
    /**
     * Get GeoTunnelReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeoTunnelReport[]|null
     */
    public function getGeoTunnelReport()
    {
        return isset($this->GeoTunnelReport) ? $this->GeoTunnelReport : null;
    }
    /**
     * Set GeoTunnelReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmGeoTunnelReport[] $geoTunnelReport
     * @return \Pcm\ArrayType\PcmArrayOfGeoTunnelReport
     */
    public function setGeoTunnelReport(array $geoTunnelReport = array())
    {
        foreach ($geoTunnelReport as $arrayOfGeoTunnelReportGeoTunnelReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeoTunnelReportGeoTunnelReportItem instanceof \Pcm\StructType\PcmGeoTunnelReport) {
                throw new \InvalidArgumentException(sprintf('The GeoTunnelReport property can only contain items of \Pcm\StructType\PcmGeoTunnelReport, "%s" given', is_object($arrayOfGeoTunnelReportGeoTunnelReportItem) ? get_class($arrayOfGeoTunnelReportGeoTunnelReportItem) : gettype($arrayOfGeoTunnelReportGeoTunnelReportItem)), __LINE__);
            }
        }
        if (is_null($geoTunnelReport) || (is_array($geoTunnelReport) && empty($geoTunnelReport))) {
            unset($this->GeoTunnelReport);
        } else {
            $this->GeoTunnelReport = $geoTunnelReport;
        }
        return $this;
    }
    /**
     * Add item to GeoTunnelReport value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmGeoTunnelReport $item
     * @return \Pcm\ArrayType\PcmArrayOfGeoTunnelReport
     */
    public function addToGeoTunnelReport(\Pcm\StructType\PcmGeoTunnelReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmGeoTunnelReport) {
            throw new \InvalidArgumentException(sprintf('The GeoTunnelReport property can only contain items of \Pcm\StructType\PcmGeoTunnelReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GeoTunnelReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmGeoTunnelReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmGeoTunnelReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmGeoTunnelReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmGeoTunnelReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmGeoTunnelReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeoTunnelReport
     */
    public function getAttributeName()
    {
        return 'GeoTunnelReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfGeoTunnelReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
