<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLeastCostReport ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLeastCostReport
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfLeastCostReport extends AbstractStructArrayBase
{
    /**
     * The LeastCostReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmLeastCostReport[]
     */
    public $LeastCostReport;
    /**
     * Constructor method for ArrayOfLeastCostReport
     * @uses PcmArrayOfLeastCostReport::setLeastCostReport()
     * @param \Pcm\StructType\PcmLeastCostReport[] $leastCostReport
     */
    public function __construct(array $leastCostReport = array())
    {
        $this
            ->setLeastCostReport($leastCostReport);
    }
    /**
     * Get LeastCostReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmLeastCostReport[]|null
     */
    public function getLeastCostReport()
    {
        return isset($this->LeastCostReport) ? $this->LeastCostReport : null;
    }
    /**
     * Set LeastCostReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmLeastCostReport[] $leastCostReport
     * @return \Pcm\ArrayType\PcmArrayOfLeastCostReport
     */
    public function setLeastCostReport(array $leastCostReport = array())
    {
        foreach ($leastCostReport as $arrayOfLeastCostReportLeastCostReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfLeastCostReportLeastCostReportItem instanceof \Pcm\StructType\PcmLeastCostReport) {
                throw new \InvalidArgumentException(sprintf('The LeastCostReport property can only contain items of \Pcm\StructType\PcmLeastCostReport, "%s" given', is_object($arrayOfLeastCostReportLeastCostReportItem) ? get_class($arrayOfLeastCostReportLeastCostReportItem) : gettype($arrayOfLeastCostReportLeastCostReportItem)), __LINE__);
            }
        }
        if (is_null($leastCostReport) || (is_array($leastCostReport) && empty($leastCostReport))) {
            unset($this->LeastCostReport);
        } else {
            $this->LeastCostReport = $leastCostReport;
        }
        return $this;
    }
    /**
     * Add item to LeastCostReport value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmLeastCostReport $item
     * @return \Pcm\ArrayType\PcmArrayOfLeastCostReport
     */
    public function addToLeastCostReport(\Pcm\StructType\PcmLeastCostReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmLeastCostReport) {
            throw new \InvalidArgumentException(sprintf('The LeastCostReport property can only contain items of \Pcm\StructType\PcmLeastCostReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LeastCostReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmLeastCostReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmLeastCostReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmLeastCostReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmLeastCostReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmLeastCostReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LeastCostReport
     */
    public function getAttributeName()
    {
        return 'LeastCostReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfLeastCostReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
