<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMileageReport ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMileageReport
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfMileageReport extends AbstractStructArrayBase
{
    /**
     * The MileageReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmMileageReport[]
     */
    public $MileageReport;
    /**
     * Constructor method for ArrayOfMileageReport
     * @uses PcmArrayOfMileageReport::setMileageReport()
     * @param \Pcm\StructType\PcmMileageReport[] $mileageReport
     */
    public function __construct(array $mileageReport = array())
    {
        $this
            ->setMileageReport($mileageReport);
    }
    /**
     * Get MileageReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmMileageReport[]|null
     */
    public function getMileageReport()
    {
        return isset($this->MileageReport) ? $this->MileageReport : null;
    }
    /**
     * Set MileageReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmMileageReport[] $mileageReport
     * @return \Pcm\ArrayType\PcmArrayOfMileageReport
     */
    public function setMileageReport(array $mileageReport = array())
    {
        foreach ($mileageReport as $arrayOfMileageReportMileageReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfMileageReportMileageReportItem instanceof \Pcm\StructType\PcmMileageReport) {
                throw new \InvalidArgumentException(sprintf('The MileageReport property can only contain items of \Pcm\StructType\PcmMileageReport, "%s" given', is_object($arrayOfMileageReportMileageReportItem) ? get_class($arrayOfMileageReportMileageReportItem) : gettype($arrayOfMileageReportMileageReportItem)), __LINE__);
            }
        }
        if (is_null($mileageReport) || (is_array($mileageReport) && empty($mileageReport))) {
            unset($this->MileageReport);
        } else {
            $this->MileageReport = $mileageReport;
        }
        return $this;
    }
    /**
     * Add item to MileageReport value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmMileageReport $item
     * @return \Pcm\ArrayType\PcmArrayOfMileageReport
     */
    public function addToMileageReport(\Pcm\StructType\PcmMileageReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmMileageReport) {
            throw new \InvalidArgumentException(sprintf('The MileageReport property can only contain items of \Pcm\StructType\PcmMileageReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MileageReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmMileageReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmMileageReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmMileageReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmMileageReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmMileageReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MileageReport
     */
    public function getAttributeName()
    {
        return 'MileageReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfMileageReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
