<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutOfRouteReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOutOfRouteReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfOutOfRouteReportLine extends AbstractStructArrayBase
{
    /**
     * The OutOfRouteReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmOutOfRouteReportLine[]
     */
    public $OutOfRouteReportLine;
    /**
     * Constructor method for ArrayOfOutOfRouteReportLine
     * @uses PcmArrayOfOutOfRouteReportLine::setOutOfRouteReportLine()
     * @param \Pcm\StructType\PcmOutOfRouteReportLine[] $outOfRouteReportLine
     */
    public function __construct(array $outOfRouteReportLine = array())
    {
        $this
            ->setOutOfRouteReportLine($outOfRouteReportLine);
    }
    /**
     * Get OutOfRouteReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmOutOfRouteReportLine[]|null
     */
    public function getOutOfRouteReportLine()
    {
        return isset($this->OutOfRouteReportLine) ? $this->OutOfRouteReportLine : null;
    }
    /**
     * Set OutOfRouteReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmOutOfRouteReportLine[] $outOfRouteReportLine
     * @return \Pcm\ArrayType\PcmArrayOfOutOfRouteReportLine
     */
    public function setOutOfRouteReportLine(array $outOfRouteReportLine = array())
    {
        foreach ($outOfRouteReportLine as $arrayOfOutOfRouteReportLineOutOfRouteReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutOfRouteReportLineOutOfRouteReportLineItem instanceof \Pcm\StructType\PcmOutOfRouteReportLine) {
                throw new \InvalidArgumentException(sprintf('The OutOfRouteReportLine property can only contain items of \Pcm\StructType\PcmOutOfRouteReportLine, "%s" given', is_object($arrayOfOutOfRouteReportLineOutOfRouteReportLineItem) ? get_class($arrayOfOutOfRouteReportLineOutOfRouteReportLineItem) : gettype($arrayOfOutOfRouteReportLineOutOfRouteReportLineItem)), __LINE__);
            }
        }
        if (is_null($outOfRouteReportLine) || (is_array($outOfRouteReportLine) && empty($outOfRouteReportLine))) {
            unset($this->OutOfRouteReportLine);
        } else {
            $this->OutOfRouteReportLine = $outOfRouteReportLine;
        }
        return $this;
    }
    /**
     * Add item to OutOfRouteReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmOutOfRouteReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfOutOfRouteReportLine
     */
    public function addToOutOfRouteReportLine(\Pcm\StructType\PcmOutOfRouteReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmOutOfRouteReportLine) {
            throw new \InvalidArgumentException(sprintf('The OutOfRouteReportLine property can only contain items of \Pcm\StructType\PcmOutOfRouteReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OutOfRouteReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmOutOfRouteReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmOutOfRouteReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmOutOfRouteReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmOutOfRouteReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmOutOfRouteReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutOfRouteReportLine
     */
    public function getAttributeName()
    {
        return 'OutOfRouteReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfOutOfRouteReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
