<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReportRouteLegacy ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReportRouteLegacy
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfReportRouteLegacy extends AbstractStructArrayBase
{
    /**
     * The ReportRouteLegacy
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmReportRouteLegacy[]
     */
    public $ReportRouteLegacy;
    /**
     * Constructor method for ArrayOfReportRouteLegacy
     * @uses PcmArrayOfReportRouteLegacy::setReportRouteLegacy()
     * @param \Pcm\StructType\PcmReportRouteLegacy[] $reportRouteLegacy
     */
    public function __construct(array $reportRouteLegacy = array())
    {
        $this
            ->setReportRouteLegacy($reportRouteLegacy);
    }
    /**
     * Get ReportRouteLegacy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmReportRouteLegacy[]|null
     */
    public function getReportRouteLegacy()
    {
        return isset($this->ReportRouteLegacy) ? $this->ReportRouteLegacy : null;
    }
    /**
     * Set ReportRouteLegacy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmReportRouteLegacy[] $reportRouteLegacy
     * @return \Pcm\ArrayType\PcmArrayOfReportRouteLegacy
     */
    public function setReportRouteLegacy(array $reportRouteLegacy = array())
    {
        foreach ($reportRouteLegacy as $arrayOfReportRouteLegacyReportRouteLegacyItem) {
            // validation for constraint: itemType
            if (!$arrayOfReportRouteLegacyReportRouteLegacyItem instanceof \Pcm\StructType\PcmReportRouteLegacy) {
                throw new \InvalidArgumentException(sprintf('The ReportRouteLegacy property can only contain items of \Pcm\StructType\PcmReportRouteLegacy, "%s" given', is_object($arrayOfReportRouteLegacyReportRouteLegacyItem) ? get_class($arrayOfReportRouteLegacyReportRouteLegacyItem) : gettype($arrayOfReportRouteLegacyReportRouteLegacyItem)), __LINE__);
            }
        }
        if (is_null($reportRouteLegacy) || (is_array($reportRouteLegacy) && empty($reportRouteLegacy))) {
            unset($this->ReportRouteLegacy);
        } else {
            $this->ReportRouteLegacy = $reportRouteLegacy;
        }
        return $this;
    }
    /**
     * Add item to ReportRouteLegacy value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmReportRouteLegacy $item
     * @return \Pcm\ArrayType\PcmArrayOfReportRouteLegacy
     */
    public function addToReportRouteLegacy(\Pcm\StructType\PcmReportRouteLegacy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmReportRouteLegacy) {
            throw new \InvalidArgumentException(sprintf('The ReportRouteLegacy property can only contain items of \Pcm\StructType\PcmReportRouteLegacy, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReportRouteLegacy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmReportRouteLegacy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmReportRouteLegacy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmReportRouteLegacy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmReportRouteLegacy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmReportRouteLegacy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReportRouteLegacy
     */
    public function getAttributeName()
    {
        return 'ReportRouteLegacy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfReportRouteLegacy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
