<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoadReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRoadReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfRoadReportLine extends AbstractStructArrayBase
{
    /**
     * The RoadReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRoadReportLine[]
     */
    public $RoadReportLine;
    /**
     * Constructor method for ArrayOfRoadReportLine
     * @uses PcmArrayOfRoadReportLine::setRoadReportLine()
     * @param \Pcm\StructType\PcmRoadReportLine[] $roadReportLine
     */
    public function __construct(array $roadReportLine = array())
    {
        $this
            ->setRoadReportLine($roadReportLine);
    }
    /**
     * Get RoadReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRoadReportLine[]|null
     */
    public function getRoadReportLine()
    {
        return isset($this->RoadReportLine) ? $this->RoadReportLine : null;
    }
    /**
     * Set RoadReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRoadReportLine[] $roadReportLine
     * @return \Pcm\ArrayType\PcmArrayOfRoadReportLine
     */
    public function setRoadReportLine(array $roadReportLine = array())
    {
        foreach ($roadReportLine as $arrayOfRoadReportLineRoadReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoadReportLineRoadReportLineItem instanceof \Pcm\StructType\PcmRoadReportLine) {
                throw new \InvalidArgumentException(sprintf('The RoadReportLine property can only contain items of \Pcm\StructType\PcmRoadReportLine, "%s" given', is_object($arrayOfRoadReportLineRoadReportLineItem) ? get_class($arrayOfRoadReportLineRoadReportLineItem) : gettype($arrayOfRoadReportLineRoadReportLineItem)), __LINE__);
            }
        }
        if (is_null($roadReportLine) || (is_array($roadReportLine) && empty($roadReportLine))) {
            unset($this->RoadReportLine);
        } else {
            $this->RoadReportLine = $roadReportLine;
        }
        return $this;
    }
    /**
     * Add item to RoadReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRoadReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfRoadReportLine
     */
    public function addToRoadReportLine(\Pcm\StructType\PcmRoadReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmRoadReportLine) {
            throw new \InvalidArgumentException(sprintf('The RoadReportLine property can only contain items of \Pcm\StructType\PcmRoadReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoadReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmRoadReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmRoadReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmRoadReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmRoadReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmRoadReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoadReportLine
     */
    public function getAttributeName()
    {
        return 'RoadReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfRoadReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
