<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStopReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStopReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfStopReportLine extends AbstractStructArrayBase
{
    /**
     * The StopReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmStopReportLine[]
     */
    public $StopReportLine;
    /**
     * Constructor method for ArrayOfStopReportLine
     * @uses PcmArrayOfStopReportLine::setStopReportLine()
     * @param \Pcm\StructType\PcmStopReportLine[] $stopReportLine
     */
    public function __construct(array $stopReportLine = array())
    {
        $this
            ->setStopReportLine($stopReportLine);
    }
    /**
     * Get StopReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmStopReportLine[]|null
     */
    public function getStopReportLine()
    {
        return isset($this->StopReportLine) ? $this->StopReportLine : null;
    }
    /**
     * Set StopReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmStopReportLine[] $stopReportLine
     * @return \Pcm\ArrayType\PcmArrayOfStopReportLine
     */
    public function setStopReportLine(array $stopReportLine = array())
    {
        foreach ($stopReportLine as $arrayOfStopReportLineStopReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfStopReportLineStopReportLineItem instanceof \Pcm\StructType\PcmStopReportLine) {
                throw new \InvalidArgumentException(sprintf('The StopReportLine property can only contain items of \Pcm\StructType\PcmStopReportLine, "%s" given', is_object($arrayOfStopReportLineStopReportLineItem) ? get_class($arrayOfStopReportLineStopReportLineItem) : gettype($arrayOfStopReportLineStopReportLineItem)), __LINE__);
            }
        }
        if (is_null($stopReportLine) || (is_array($stopReportLine) && empty($stopReportLine))) {
            unset($this->StopReportLine);
        } else {
            $this->StopReportLine = $stopReportLine;
        }
        return $this;
    }
    /**
     * Add item to StopReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmStopReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfStopReportLine
     */
    public function addToStopReportLine(\Pcm\StructType\PcmStopReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmStopReportLine) {
            throw new \InvalidArgumentException(sprintf('The StopReportLine property can only contain items of \Pcm\StructType\PcmStopReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StopReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmStopReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmStopReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmStopReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmStopReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmStopReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StopReportLine
     */
    public function getAttributeName()
    {
        return 'StopReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfStopReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
