<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ComparisonReportLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ComparisonReportLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmComparisonReportLine extends AbstractStructBase
{
    /**
     * The LeastCostTripOptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LeastCostTripOptions;
    /**
     * The Route
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Route;
    /**
     * The Miles
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Miles;
    /**
     * The Cost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Cost;
    /**
     * The Hours
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Hours;
    /**
     * The Tolls
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tolls;
    /**
     * The Labor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Labor;
    /**
     * The Other
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Other;
    /**
     * The Estghg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Estghg;
    /**
     * The Fuel
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Fuel;
    /**
     * Constructor method for ComparisonReportLine
     * @uses PcmComparisonReportLine::setLeastCostTripOptions()
     * @uses PcmComparisonReportLine::setRoute()
     * @uses PcmComparisonReportLine::setMiles()
     * @uses PcmComparisonReportLine::setCost()
     * @uses PcmComparisonReportLine::setHours()
     * @uses PcmComparisonReportLine::setTolls()
     * @uses PcmComparisonReportLine::setLabor()
     * @uses PcmComparisonReportLine::setOther()
     * @uses PcmComparisonReportLine::setEstghg()
     * @uses PcmComparisonReportLine::setFuel()
     * @param string $leastCostTripOptions
     * @param string $route
     * @param string $miles
     * @param string $cost
     * @param string $hours
     * @param string $tolls
     * @param string $labor
     * @param string $other
     * @param string $estghg
     * @param string $fuel
     */
    public function __construct($leastCostTripOptions = null, $route = null, $miles = null, $cost = null, $hours = null, $tolls = null, $labor = null, $other = null, $estghg = null, $fuel = null)
    {
        $this
            ->setLeastCostTripOptions($leastCostTripOptions)
            ->setRoute($route)
            ->setMiles($miles)
            ->setCost($cost)
            ->setHours($hours)
            ->setTolls($tolls)
            ->setLabor($labor)
            ->setOther($other)
            ->setEstghg($estghg)
            ->setFuel($fuel);
    }
    /**
     * Get LeastCostTripOptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLeastCostTripOptions()
    {
        return isset($this->LeastCostTripOptions) ? $this->LeastCostTripOptions : null;
    }
    /**
     * Set LeastCostTripOptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $leastCostTripOptions
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setLeastCostTripOptions($leastCostTripOptions = null)
    {
        // validation for constraint: string
        if (!is_null($leastCostTripOptions) && !is_string($leastCostTripOptions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($leastCostTripOptions)), __LINE__);
        }
        if (is_null($leastCostTripOptions) || (is_array($leastCostTripOptions) && empty($leastCostTripOptions))) {
            unset($this->LeastCostTripOptions);
        } else {
            $this->LeastCostTripOptions = $leastCostTripOptions;
        }
        return $this;
    }
    /**
     * Get Route value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRoute()
    {
        return isset($this->Route) ? $this->Route : null;
    }
    /**
     * Set Route value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $route
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setRoute($route = null)
    {
        // validation for constraint: string
        if (!is_null($route) && !is_string($route)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($route)), __LINE__);
        }
        if (is_null($route) || (is_array($route) && empty($route))) {
            unset($this->Route);
        } else {
            $this->Route = $route;
        }
        return $this;
    }
    /**
     * Get Miles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMiles()
    {
        return isset($this->Miles) ? $this->Miles : null;
    }
    /**
     * Set Miles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $miles
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setMiles($miles = null)
    {
        // validation for constraint: string
        if (!is_null($miles) && !is_string($miles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($miles)), __LINE__);
        }
        if (is_null($miles) || (is_array($miles) && empty($miles))) {
            unset($this->Miles);
        } else {
            $this->Miles = $miles;
        }
        return $this;
    }
    /**
     * Get Cost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCost()
    {
        return isset($this->Cost) ? $this->Cost : null;
    }
    /**
     * Set Cost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cost
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setCost($cost = null)
    {
        // validation for constraint: string
        if (!is_null($cost) && !is_string($cost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cost)), __LINE__);
        }
        if (is_null($cost) || (is_array($cost) && empty($cost))) {
            unset($this->Cost);
        } else {
            $this->Cost = $cost;
        }
        return $this;
    }
    /**
     * Get Hours value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHours()
    {
        return isset($this->Hours) ? $this->Hours : null;
    }
    /**
     * Set Hours value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $hours
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setHours($hours = null)
    {
        // validation for constraint: string
        if (!is_null($hours) && !is_string($hours)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hours)), __LINE__);
        }
        if (is_null($hours) || (is_array($hours) && empty($hours))) {
            unset($this->Hours);
        } else {
            $this->Hours = $hours;
        }
        return $this;
    }
    /**
     * Get Tolls value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTolls()
    {
        return isset($this->Tolls) ? $this->Tolls : null;
    }
    /**
     * Set Tolls value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tolls
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setTolls($tolls = null)
    {
        // validation for constraint: string
        if (!is_null($tolls) && !is_string($tolls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tolls)), __LINE__);
        }
        if (is_null($tolls) || (is_array($tolls) && empty($tolls))) {
            unset($this->Tolls);
        } else {
            $this->Tolls = $tolls;
        }
        return $this;
    }
    /**
     * Get Labor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabor()
    {
        return isset($this->Labor) ? $this->Labor : null;
    }
    /**
     * Set Labor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $labor
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setLabor($labor = null)
    {
        // validation for constraint: string
        if (!is_null($labor) && !is_string($labor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($labor)), __LINE__);
        }
        if (is_null($labor) || (is_array($labor) && empty($labor))) {
            unset($this->Labor);
        } else {
            $this->Labor = $labor;
        }
        return $this;
    }
    /**
     * Get Other value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOther()
    {
        return isset($this->Other) ? $this->Other : null;
    }
    /**
     * Set Other value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $other
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setOther($other = null)
    {
        // validation for constraint: string
        if (!is_null($other) && !is_string($other)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($other)), __LINE__);
        }
        if (is_null($other) || (is_array($other) && empty($other))) {
            unset($this->Other);
        } else {
            $this->Other = $other;
        }
        return $this;
    }
    /**
     * Get Estghg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEstghg()
    {
        return isset($this->Estghg) ? $this->Estghg : null;
    }
    /**
     * Set Estghg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $estghg
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setEstghg($estghg = null)
    {
        // validation for constraint: string
        if (!is_null($estghg) && !is_string($estghg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($estghg)), __LINE__);
        }
        if (is_null($estghg) || (is_array($estghg) && empty($estghg))) {
            unset($this->Estghg);
        } else {
            $this->Estghg = $estghg;
        }
        return $this;
    }
    /**
     * Get Fuel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFuel()
    {
        return isset($this->Fuel) ? $this->Fuel : null;
    }
    /**
     * Set Fuel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fuel
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public function setFuel($fuel = null)
    {
        // validation for constraint: string
        if (!is_null($fuel) && !is_string($fuel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fuel)), __LINE__);
        }
        if (is_null($fuel) || (is_array($fuel) && empty($fuel))) {
            unset($this->Fuel);
        } else {
            $this->Fuel = $fuel;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmComparisonReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
