<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DirectionsReportLeg StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DirectionsReportLeg
 * @package Pcm
 * @subpackage Structs
 */
class PcmDirectionsReportLeg extends AbstractStructBase
{
    /**
     * The Origin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeocodeOutputLocation
     */
    public $Origin;
    /**
     * The ReportLines
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfDirectionsReportLine
     */
    public $ReportLines;
    /**
     * The Dest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeocodeOutputLocation
     */
    public $Dest;
    /**
     * Constructor method for DirectionsReportLeg
     * @uses PcmDirectionsReportLeg::setOrigin()
     * @uses PcmDirectionsReportLeg::setReportLines()
     * @uses PcmDirectionsReportLeg::setDest()
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $origin
     * @param \Pcm\ArrayType\PcmArrayOfDirectionsReportLine $reportLines
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $dest
     */
    public function __construct(\Pcm\StructType\PcmGeocodeOutputLocation $origin = null, \Pcm\ArrayType\PcmArrayOfDirectionsReportLine $reportLines = null, \Pcm\StructType\PcmGeocodeOutputLocation $dest = null)
    {
        $this
            ->setOrigin($origin)
            ->setReportLines($reportLines)
            ->setDest($dest);
    }
    /**
     * Get Origin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeocodeOutputLocation|null
     */
    public function getOrigin()
    {
        return isset($this->Origin) ? $this->Origin : null;
    }
    /**
     * Set Origin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $origin
     * @return \Pcm\StructType\PcmDirectionsReportLeg
     */
    public function setOrigin(\Pcm\StructType\PcmGeocodeOutputLocation $origin = null)
    {
        if (is_null($origin) || (is_array($origin) && empty($origin))) {
            unset($this->Origin);
        } else {
            $this->Origin = $origin;
        }
        return $this;
    }
    /**
     * Get ReportLines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfDirectionsReportLine|null
     */
    public function getReportLines()
    {
        return isset($this->ReportLines) ? $this->ReportLines : null;
    }
    /**
     * Set ReportLines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfDirectionsReportLine $reportLines
     * @return \Pcm\StructType\PcmDirectionsReportLeg
     */
    public function setReportLines(\Pcm\ArrayType\PcmArrayOfDirectionsReportLine $reportLines = null)
    {
        if (is_null($reportLines) || (is_array($reportLines) && empty($reportLines))) {
            unset($this->ReportLines);
        } else {
            $this->ReportLines = $reportLines;
        }
        return $this;
    }
    /**
     * Get Dest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeocodeOutputLocation|null
     */
    public function getDest()
    {
        return isset($this->Dest) ? $this->Dest : null;
    }
    /**
     * Set Dest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $dest
     * @return \Pcm\StructType\PcmDirectionsReportLeg
     */
    public function setDest(\Pcm\StructType\PcmGeocodeOutputLocation $dest = null)
    {
        if (is_null($dest) || (is_array($dest) && empty($dest))) {
            unset($this->Dest);
        } else {
            $this->Dest = $dest;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmDirectionsReportLeg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
