<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FuelStopLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FuelStopLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmFuelStopLine extends AbstractStructBase
{
    /**
     * The FuelLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeocodeOutputLocation
     */
    public $FuelLocation;
    /**
     * The FuelPur
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FuelPur;
    /**
     * The FuelCost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FuelCost;
    /**
     * The FuelFill
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FuelFill;
    /**
     * Constructor method for FuelStopLine
     * @uses PcmFuelStopLine::setFuelLocation()
     * @uses PcmFuelStopLine::setFuelPur()
     * @uses PcmFuelStopLine::setFuelCost()
     * @uses PcmFuelStopLine::setFuelFill()
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $fuelLocation
     * @param string $fuelPur
     * @param string $fuelCost
     * @param string $fuelFill
     */
    public function __construct(\Pcm\StructType\PcmGeocodeOutputLocation $fuelLocation = null, $fuelPur = null, $fuelCost = null, $fuelFill = null)
    {
        $this
            ->setFuelLocation($fuelLocation)
            ->setFuelPur($fuelPur)
            ->setFuelCost($fuelCost)
            ->setFuelFill($fuelFill);
    }
    /**
     * Get FuelLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeocodeOutputLocation|null
     */
    public function getFuelLocation()
    {
        return isset($this->FuelLocation) ? $this->FuelLocation : null;
    }
    /**
     * Set FuelLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $fuelLocation
     * @return \Pcm\StructType\PcmFuelStopLine
     */
    public function setFuelLocation(\Pcm\StructType\PcmGeocodeOutputLocation $fuelLocation = null)
    {
        if (is_null($fuelLocation) || (is_array($fuelLocation) && empty($fuelLocation))) {
            unset($this->FuelLocation);
        } else {
            $this->FuelLocation = $fuelLocation;
        }
        return $this;
    }
    /**
     * Get FuelPur value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFuelPur()
    {
        return isset($this->FuelPur) ? $this->FuelPur : null;
    }
    /**
     * Set FuelPur value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fuelPur
     * @return \Pcm\StructType\PcmFuelStopLine
     */
    public function setFuelPur($fuelPur = null)
    {
        // validation for constraint: string
        if (!is_null($fuelPur) && !is_string($fuelPur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fuelPur)), __LINE__);
        }
        if (is_null($fuelPur) || (is_array($fuelPur) && empty($fuelPur))) {
            unset($this->FuelPur);
        } else {
            $this->FuelPur = $fuelPur;
        }
        return $this;
    }
    /**
     * Get FuelCost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFuelCost()
    {
        return isset($this->FuelCost) ? $this->FuelCost : null;
    }
    /**
     * Set FuelCost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fuelCost
     * @return \Pcm\StructType\PcmFuelStopLine
     */
    public function setFuelCost($fuelCost = null)
    {
        // validation for constraint: string
        if (!is_null($fuelCost) && !is_string($fuelCost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fuelCost)), __LINE__);
        }
        if (is_null($fuelCost) || (is_array($fuelCost) && empty($fuelCost))) {
            unset($this->FuelCost);
        } else {
            $this->FuelCost = $fuelCost;
        }
        return $this;
    }
    /**
     * Get FuelFill value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFuelFill()
    {
        return isset($this->FuelFill) ? $this->FuelFill : null;
    }
    /**
     * Set FuelFill value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fuelFill
     * @return \Pcm\StructType\PcmFuelStopLine
     */
    public function setFuelFill($fuelFill = null)
    {
        // validation for constraint: string
        if (!is_null($fuelFill) && !is_string($fuelFill)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fuelFill)), __LINE__);
        }
        if (is_null($fuelFill) || (is_array($fuelFill) && empty($fuelFill))) {
            unset($this->FuelFill);
        } else {
            $this->FuelFill = $fuelFill;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmFuelStopLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
