<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for POIAlongRouteMatch StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:POIAlongRouteMatch
 * @package Pcm
 * @subpackage Structs
 */
class PcmPOIAlongRouteMatch extends AbstractStructBase
{
    /**
     * The POILocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmLocation
     */
    public $POILocation;
    /**
     * The DistanceFromOrigin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDistance
     */
    public $DistanceFromOrigin;
    /**
     * The POICategory
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $POICategory;
    /**
     * The TimeFromOrigin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TimeFromOrigin;
    /**
     * The DistanceOffRoute
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDistance
     */
    public $DistanceOffRoute;
    /**
     * Constructor method for POIAlongRouteMatch
     * @uses PcmPOIAlongRouteMatch::setPOILocation()
     * @uses PcmPOIAlongRouteMatch::setDistanceFromOrigin()
     * @uses PcmPOIAlongRouteMatch::setPOICategory()
     * @uses PcmPOIAlongRouteMatch::setTimeFromOrigin()
     * @uses PcmPOIAlongRouteMatch::setDistanceOffRoute()
     * @param \Pcm\StructType\PcmLocation $pOILocation
     * @param \Pcm\StructType\PcmDistance $distanceFromOrigin
     * @param string $pOICategory
     * @param string $timeFromOrigin
     * @param \Pcm\StructType\PcmDistance $distanceOffRoute
     */
    public function __construct(\Pcm\StructType\PcmLocation $pOILocation = null, \Pcm\StructType\PcmDistance $distanceFromOrigin = null, $pOICategory = null, $timeFromOrigin = null, \Pcm\StructType\PcmDistance $distanceOffRoute = null)
    {
        $this
            ->setPOILocation($pOILocation)
            ->setDistanceFromOrigin($distanceFromOrigin)
            ->setPOICategory($pOICategory)
            ->setTimeFromOrigin($timeFromOrigin)
            ->setDistanceOffRoute($distanceOffRoute);
    }
    /**
     * Get POILocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmLocation|null
     */
    public function getPOILocation()
    {
        return isset($this->POILocation) ? $this->POILocation : null;
    }
    /**
     * Set POILocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmLocation $pOILocation
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public function setPOILocation(\Pcm\StructType\PcmLocation $pOILocation = null)
    {
        if (is_null($pOILocation) || (is_array($pOILocation) && empty($pOILocation))) {
            unset($this->POILocation);
        } else {
            $this->POILocation = $pOILocation;
        }
        return $this;
    }
    /**
     * Get DistanceFromOrigin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDistance|null
     */
    public function getDistanceFromOrigin()
    {
        return isset($this->DistanceFromOrigin) ? $this->DistanceFromOrigin : null;
    }
    /**
     * Set DistanceFromOrigin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmDistance $distanceFromOrigin
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public function setDistanceFromOrigin(\Pcm\StructType\PcmDistance $distanceFromOrigin = null)
    {
        if (is_null($distanceFromOrigin) || (is_array($distanceFromOrigin) && empty($distanceFromOrigin))) {
            unset($this->DistanceFromOrigin);
        } else {
            $this->DistanceFromOrigin = $distanceFromOrigin;
        }
        return $this;
    }
    /**
     * Get POICategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPOICategory()
    {
        return isset($this->POICategory) ? $this->POICategory : null;
    }
    /**
     * Set POICategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pOICategory
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public function setPOICategory($pOICategory = null)
    {
        // validation for constraint: string
        if (!is_null($pOICategory) && !is_string($pOICategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pOICategory)), __LINE__);
        }
        if (is_null($pOICategory) || (is_array($pOICategory) && empty($pOICategory))) {
            unset($this->POICategory);
        } else {
            $this->POICategory = $pOICategory;
        }
        return $this;
    }
    /**
     * Get TimeFromOrigin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTimeFromOrigin()
    {
        return isset($this->TimeFromOrigin) ? $this->TimeFromOrigin : null;
    }
    /**
     * Set TimeFromOrigin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $timeFromOrigin
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public function setTimeFromOrigin($timeFromOrigin = null)
    {
        // validation for constraint: string
        if (!is_null($timeFromOrigin) && !is_string($timeFromOrigin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeFromOrigin)), __LINE__);
        }
        if (is_null($timeFromOrigin) || (is_array($timeFromOrigin) && empty($timeFromOrigin))) {
            unset($this->TimeFromOrigin);
        } else {
            $this->TimeFromOrigin = $timeFromOrigin;
        }
        return $this;
    }
    /**
     * Get DistanceOffRoute value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDistance|null
     */
    public function getDistanceOffRoute()
    {
        return isset($this->DistanceOffRoute) ? $this->DistanceOffRoute : null;
    }
    /**
     * Set DistanceOffRoute value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmDistance $distanceOffRoute
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public function setDistanceOffRoute(\Pcm\StructType\PcmDistance $distanceOffRoute = null)
    {
        if (is_null($distanceOffRoute) || (is_array($distanceOffRoute) && empty($distanceOffRoute))) {
            unset($this->DistanceOffRoute);
        } else {
            $this->DistanceOffRoute = $distanceOffRoute;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
