<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportRouteLegacy StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ReportRouteLegacy
 * @package Pcm
 * @subpackage Structs
 */
class PcmReportRouteLegacy extends PcmRoute
{
    /**
     * The ReportingOptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmReportOptions
     */
    public $ReportingOptions;
    /**
     * The MileageReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmMileageReportType
     */
    public $MileageReportRequest;
    /**
     * The DetailReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDetailReportType
     */
    public $DetailReportRequest;
    /**
     * The DirectionsReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDirectionsReportType
     */
    public $DirectionsReportRequest;
    /**
     * The RoadReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRoadReportType
     */
    public $RoadReportRequest;
    /**
     * The StateReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmStateReportType
     */
    public $StateReportRequest;
    /**
     * The LeastCostReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmLeastCostReportType
     */
    public $LeastCostReportRequest;
    /**
     * The GeoTunnelReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeoTunnelReportType
     */
    public $GeoTunnelReportRequest;
    /**
     * The WeatherAlertsReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmWeatherAlertsReportType
     */
    public $WeatherAlertsReportRequest;
    /**
     * The CalculateMilesReportRequest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmCalculateMilesReportType
     */
    public $CalculateMilesReportRequest;
    /**
     * Constructor method for ReportRouteLegacy
     * @uses PcmReportRouteLegacy::setReportingOptions()
     * @uses PcmReportRouteLegacy::setMileageReportRequest()
     * @uses PcmReportRouteLegacy::setDetailReportRequest()
     * @uses PcmReportRouteLegacy::setDirectionsReportRequest()
     * @uses PcmReportRouteLegacy::setRoadReportRequest()
     * @uses PcmReportRouteLegacy::setStateReportRequest()
     * @uses PcmReportRouteLegacy::setLeastCostReportRequest()
     * @uses PcmReportRouteLegacy::setGeoTunnelReportRequest()
     * @uses PcmReportRouteLegacy::setWeatherAlertsReportRequest()
     * @uses PcmReportRouteLegacy::setCalculateMilesReportRequest()
     * @param \Pcm\StructType\PcmReportOptions $reportingOptions
     * @param \Pcm\StructType\PcmMileageReportType $mileageReportRequest
     * @param \Pcm\StructType\PcmDetailReportType $detailReportRequest
     * @param \Pcm\StructType\PcmDirectionsReportType $directionsReportRequest
     * @param \Pcm\StructType\PcmRoadReportType $roadReportRequest
     * @param \Pcm\StructType\PcmStateReportType $stateReportRequest
     * @param \Pcm\StructType\PcmLeastCostReportType $leastCostReportRequest
     * @param \Pcm\StructType\PcmGeoTunnelReportType $geoTunnelReportRequest
     * @param \Pcm\StructType\PcmWeatherAlertsReportType $weatherAlertsReportRequest
     * @param \Pcm\StructType\PcmCalculateMilesReportType $calculateMilesReportRequest
     */
    public function __construct(\Pcm\StructType\PcmReportOptions $reportingOptions = null, \Pcm\StructType\PcmMileageReportType $mileageReportRequest = null, \Pcm\StructType\PcmDetailReportType $detailReportRequest = null, \Pcm\StructType\PcmDirectionsReportType $directionsReportRequest = null, \Pcm\StructType\PcmRoadReportType $roadReportRequest = null, \Pcm\StructType\PcmStateReportType $stateReportRequest = null, \Pcm\StructType\PcmLeastCostReportType $leastCostReportRequest = null, \Pcm\StructType\PcmGeoTunnelReportType $geoTunnelReportRequest = null, \Pcm\StructType\PcmWeatherAlertsReportType $weatherAlertsReportRequest = null, \Pcm\StructType\PcmCalculateMilesReportType $calculateMilesReportRequest = null)
    {
        $this
            ->setReportingOptions($reportingOptions)
            ->setMileageReportRequest($mileageReportRequest)
            ->setDetailReportRequest($detailReportRequest)
            ->setDirectionsReportRequest($directionsReportRequest)
            ->setRoadReportRequest($roadReportRequest)
            ->setStateReportRequest($stateReportRequest)
            ->setLeastCostReportRequest($leastCostReportRequest)
            ->setGeoTunnelReportRequest($geoTunnelReportRequest)
            ->setWeatherAlertsReportRequest($weatherAlertsReportRequest)
            ->setCalculateMilesReportRequest($calculateMilesReportRequest);
    }
    /**
     * Get ReportingOptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmReportOptions|null
     */
    public function getReportingOptions()
    {
        return isset($this->ReportingOptions) ? $this->ReportingOptions : null;
    }
    /**
     * Set ReportingOptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmReportOptions $reportingOptions
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setReportingOptions(\Pcm\StructType\PcmReportOptions $reportingOptions = null)
    {
        if (is_null($reportingOptions) || (is_array($reportingOptions) && empty($reportingOptions))) {
            unset($this->ReportingOptions);
        } else {
            $this->ReportingOptions = $reportingOptions;
        }
        return $this;
    }
    /**
     * Get MileageReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmMileageReportType|null
     */
    public function getMileageReportRequest()
    {
        return isset($this->MileageReportRequest) ? $this->MileageReportRequest : null;
    }
    /**
     * Set MileageReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmMileageReportType $mileageReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setMileageReportRequest(\Pcm\StructType\PcmMileageReportType $mileageReportRequest = null)
    {
        if (is_null($mileageReportRequest) || (is_array($mileageReportRequest) && empty($mileageReportRequest))) {
            unset($this->MileageReportRequest);
        } else {
            $this->MileageReportRequest = $mileageReportRequest;
        }
        return $this;
    }
    /**
     * Get DetailReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDetailReportType|null
     */
    public function getDetailReportRequest()
    {
        return isset($this->DetailReportRequest) ? $this->DetailReportRequest : null;
    }
    /**
     * Set DetailReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmDetailReportType $detailReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setDetailReportRequest(\Pcm\StructType\PcmDetailReportType $detailReportRequest = null)
    {
        if (is_null($detailReportRequest) || (is_array($detailReportRequest) && empty($detailReportRequest))) {
            unset($this->DetailReportRequest);
        } else {
            $this->DetailReportRequest = $detailReportRequest;
        }
        return $this;
    }
    /**
     * Get DirectionsReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDirectionsReportType|null
     */
    public function getDirectionsReportRequest()
    {
        return isset($this->DirectionsReportRequest) ? $this->DirectionsReportRequest : null;
    }
    /**
     * Set DirectionsReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmDirectionsReportType $directionsReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setDirectionsReportRequest(\Pcm\StructType\PcmDirectionsReportType $directionsReportRequest = null)
    {
        if (is_null($directionsReportRequest) || (is_array($directionsReportRequest) && empty($directionsReportRequest))) {
            unset($this->DirectionsReportRequest);
        } else {
            $this->DirectionsReportRequest = $directionsReportRequest;
        }
        return $this;
    }
    /**
     * Get RoadReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRoadReportType|null
     */
    public function getRoadReportRequest()
    {
        return isset($this->RoadReportRequest) ? $this->RoadReportRequest : null;
    }
    /**
     * Set RoadReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmRoadReportType $roadReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setRoadReportRequest(\Pcm\StructType\PcmRoadReportType $roadReportRequest = null)
    {
        if (is_null($roadReportRequest) || (is_array($roadReportRequest) && empty($roadReportRequest))) {
            unset($this->RoadReportRequest);
        } else {
            $this->RoadReportRequest = $roadReportRequest;
        }
        return $this;
    }
    /**
     * Get StateReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmStateReportType|null
     */
    public function getStateReportRequest()
    {
        return isset($this->StateReportRequest) ? $this->StateReportRequest : null;
    }
    /**
     * Set StateReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmStateReportType $stateReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setStateReportRequest(\Pcm\StructType\PcmStateReportType $stateReportRequest = null)
    {
        if (is_null($stateReportRequest) || (is_array($stateReportRequest) && empty($stateReportRequest))) {
            unset($this->StateReportRequest);
        } else {
            $this->StateReportRequest = $stateReportRequest;
        }
        return $this;
    }
    /**
     * Get LeastCostReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmLeastCostReportType|null
     */
    public function getLeastCostReportRequest()
    {
        return isset($this->LeastCostReportRequest) ? $this->LeastCostReportRequest : null;
    }
    /**
     * Set LeastCostReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmLeastCostReportType $leastCostReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setLeastCostReportRequest(\Pcm\StructType\PcmLeastCostReportType $leastCostReportRequest = null)
    {
        if (is_null($leastCostReportRequest) || (is_array($leastCostReportRequest) && empty($leastCostReportRequest))) {
            unset($this->LeastCostReportRequest);
        } else {
            $this->LeastCostReportRequest = $leastCostReportRequest;
        }
        return $this;
    }
    /**
     * Get GeoTunnelReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeoTunnelReportType|null
     */
    public function getGeoTunnelReportRequest()
    {
        return isset($this->GeoTunnelReportRequest) ? $this->GeoTunnelReportRequest : null;
    }
    /**
     * Set GeoTunnelReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeoTunnelReportType $geoTunnelReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setGeoTunnelReportRequest(\Pcm\StructType\PcmGeoTunnelReportType $geoTunnelReportRequest = null)
    {
        if (is_null($geoTunnelReportRequest) || (is_array($geoTunnelReportRequest) && empty($geoTunnelReportRequest))) {
            unset($this->GeoTunnelReportRequest);
        } else {
            $this->GeoTunnelReportRequest = $geoTunnelReportRequest;
        }
        return $this;
    }
    /**
     * Get WeatherAlertsReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmWeatherAlertsReportType|null
     */
    public function getWeatherAlertsReportRequest()
    {
        return isset($this->WeatherAlertsReportRequest) ? $this->WeatherAlertsReportRequest : null;
    }
    /**
     * Set WeatherAlertsReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmWeatherAlertsReportType $weatherAlertsReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setWeatherAlertsReportRequest(\Pcm\StructType\PcmWeatherAlertsReportType $weatherAlertsReportRequest = null)
    {
        if (is_null($weatherAlertsReportRequest) || (is_array($weatherAlertsReportRequest) && empty($weatherAlertsReportRequest))) {
            unset($this->WeatherAlertsReportRequest);
        } else {
            $this->WeatherAlertsReportRequest = $weatherAlertsReportRequest;
        }
        return $this;
    }
    /**
     * Get CalculateMilesReportRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmCalculateMilesReportType|null
     */
    public function getCalculateMilesReportRequest()
    {
        return isset($this->CalculateMilesReportRequest) ? $this->CalculateMilesReportRequest : null;
    }
    /**
     * Set CalculateMilesReportRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmCalculateMilesReportType $calculateMilesReportRequest
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public function setCalculateMilesReportRequest(\Pcm\StructType\PcmCalculateMilesReportType $calculateMilesReportRequest = null)
    {
        if (is_null($calculateMilesReportRequest) || (is_array($calculateMilesReportRequest) && empty($calculateMilesReportRequest))) {
            unset($this->CalculateMilesReportRequest);
        } else {
            $this->CalculateMilesReportRequest = $calculateMilesReportRequest;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmReportRouteLegacy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
