<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoadReport StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RoadReport
 * @package Pcm
 * @subpackage Structs
 */
class PcmRoadReport extends PcmReport
{
    /**
     * The ReportLines
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfRoadReportLine
     */
    public $ReportLines;
    /**
     * The Disclaimers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfstring
     */
    public $Disclaimers;
    /**
     * Constructor method for RoadReport
     * @uses PcmRoadReport::setReportLines()
     * @uses PcmRoadReport::setDisclaimers()
     * @param \Pcm\ArrayType\PcmArrayOfRoadReportLine $reportLines
     * @param \Pcm\ArrayType\PcmArrayOfstring $disclaimers
     */
    public function __construct(\Pcm\ArrayType\PcmArrayOfRoadReportLine $reportLines = null, \Pcm\ArrayType\PcmArrayOfstring $disclaimers = null)
    {
        $this
            ->setReportLines($reportLines)
            ->setDisclaimers($disclaimers);
    }
    /**
     * Get ReportLines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfRoadReportLine|null
     */
    public function getReportLines()
    {
        return isset($this->ReportLines) ? $this->ReportLines : null;
    }
    /**
     * Set ReportLines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfRoadReportLine $reportLines
     * @return \Pcm\StructType\PcmRoadReport
     */
    public function setReportLines(\Pcm\ArrayType\PcmArrayOfRoadReportLine $reportLines = null)
    {
        if (is_null($reportLines) || (is_array($reportLines) && empty($reportLines))) {
            unset($this->ReportLines);
        } else {
            $this->ReportLines = $reportLines;
        }
        return $this;
    }
    /**
     * Get Disclaimers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfstring|null
     */
    public function getDisclaimers()
    {
        return isset($this->Disclaimers) ? $this->Disclaimers : null;
    }
    /**
     * Set Disclaimers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfstring $disclaimers
     * @return \Pcm\StructType\PcmRoadReport
     */
    public function setDisclaimers(\Pcm\ArrayType\PcmArrayOfstring $disclaimers = null)
    {
        if (is_null($disclaimers) || (is_array($disclaimers) && empty($disclaimers))) {
            unset($this->Disclaimers);
        } else {
            $this->Disclaimers = $disclaimers;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmRoadReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
