<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoadReportLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RoadReportLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmRoadReportLine extends AbstractStructBase
{
    /**
     * The Stop
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeocodeOutputLocation
     */
    public $Stop;
    /**
     * The LMiles
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LMiles;
    /**
     * The InterSt
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InterSt;
    /**
     * The InterstNoRamp
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InterstNoRamp;
    /**
     * The Divide
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Divide;
    /**
     * The Prime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Prime;
    /**
     * The Second
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Second;
    /**
     * The Ferry
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ferry;
    /**
     * The Ramp
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ramp;
    /**
     * The Local
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Local;
    /**
     * The Toll
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Toll;
    /**
     * The Energy
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Energy;
    /**
     * Constructor method for RoadReportLine
     * @uses PcmRoadReportLine::setStop()
     * @uses PcmRoadReportLine::setLMiles()
     * @uses PcmRoadReportLine::setInterSt()
     * @uses PcmRoadReportLine::setInterstNoRamp()
     * @uses PcmRoadReportLine::setDivide()
     * @uses PcmRoadReportLine::setPrime()
     * @uses PcmRoadReportLine::setSecond()
     * @uses PcmRoadReportLine::setFerry()
     * @uses PcmRoadReportLine::setRamp()
     * @uses PcmRoadReportLine::setLocal()
     * @uses PcmRoadReportLine::setToll()
     * @uses PcmRoadReportLine::setEnergy()
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $stop
     * @param string $lMiles
     * @param string $interSt
     * @param string $interstNoRamp
     * @param string $divide
     * @param string $prime
     * @param string $second
     * @param string $ferry
     * @param string $ramp
     * @param string $local
     * @param string $toll
     * @param string $energy
     */
    public function __construct(\Pcm\StructType\PcmGeocodeOutputLocation $stop = null, $lMiles = null, $interSt = null, $interstNoRamp = null, $divide = null, $prime = null, $second = null, $ferry = null, $ramp = null, $local = null, $toll = null, $energy = null)
    {
        $this
            ->setStop($stop)
            ->setLMiles($lMiles)
            ->setInterSt($interSt)
            ->setInterstNoRamp($interstNoRamp)
            ->setDivide($divide)
            ->setPrime($prime)
            ->setSecond($second)
            ->setFerry($ferry)
            ->setRamp($ramp)
            ->setLocal($local)
            ->setToll($toll)
            ->setEnergy($energy);
    }
    /**
     * Get Stop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeocodeOutputLocation|null
     */
    public function getStop()
    {
        return isset($this->Stop) ? $this->Stop : null;
    }
    /**
     * Set Stop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $stop
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setStop(\Pcm\StructType\PcmGeocodeOutputLocation $stop = null)
    {
        if (is_null($stop) || (is_array($stop) && empty($stop))) {
            unset($this->Stop);
        } else {
            $this->Stop = $stop;
        }
        return $this;
    }
    /**
     * Get LMiles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLMiles()
    {
        return isset($this->LMiles) ? $this->LMiles : null;
    }
    /**
     * Set LMiles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lMiles
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setLMiles($lMiles = null)
    {
        // validation for constraint: string
        if (!is_null($lMiles) && !is_string($lMiles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lMiles)), __LINE__);
        }
        if (is_null($lMiles) || (is_array($lMiles) && empty($lMiles))) {
            unset($this->LMiles);
        } else {
            $this->LMiles = $lMiles;
        }
        return $this;
    }
    /**
     * Get InterSt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInterSt()
    {
        return isset($this->InterSt) ? $this->InterSt : null;
    }
    /**
     * Set InterSt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $interSt
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setInterSt($interSt = null)
    {
        // validation for constraint: string
        if (!is_null($interSt) && !is_string($interSt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($interSt)), __LINE__);
        }
        if (is_null($interSt) || (is_array($interSt) && empty($interSt))) {
            unset($this->InterSt);
        } else {
            $this->InterSt = $interSt;
        }
        return $this;
    }
    /**
     * Get InterstNoRamp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInterstNoRamp()
    {
        return isset($this->InterstNoRamp) ? $this->InterstNoRamp : null;
    }
    /**
     * Set InterstNoRamp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $interstNoRamp
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setInterstNoRamp($interstNoRamp = null)
    {
        // validation for constraint: string
        if (!is_null($interstNoRamp) && !is_string($interstNoRamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($interstNoRamp)), __LINE__);
        }
        if (is_null($interstNoRamp) || (is_array($interstNoRamp) && empty($interstNoRamp))) {
            unset($this->InterstNoRamp);
        } else {
            $this->InterstNoRamp = $interstNoRamp;
        }
        return $this;
    }
    /**
     * Get Divide value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDivide()
    {
        return isset($this->Divide) ? $this->Divide : null;
    }
    /**
     * Set Divide value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $divide
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setDivide($divide = null)
    {
        // validation for constraint: string
        if (!is_null($divide) && !is_string($divide)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($divide)), __LINE__);
        }
        if (is_null($divide) || (is_array($divide) && empty($divide))) {
            unset($this->Divide);
        } else {
            $this->Divide = $divide;
        }
        return $this;
    }
    /**
     * Get Prime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPrime()
    {
        return isset($this->Prime) ? $this->Prime : null;
    }
    /**
     * Set Prime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $prime
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setPrime($prime = null)
    {
        // validation for constraint: string
        if (!is_null($prime) && !is_string($prime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prime)), __LINE__);
        }
        if (is_null($prime) || (is_array($prime) && empty($prime))) {
            unset($this->Prime);
        } else {
            $this->Prime = $prime;
        }
        return $this;
    }
    /**
     * Get Second value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSecond()
    {
        return isset($this->Second) ? $this->Second : null;
    }
    /**
     * Set Second value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $second
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setSecond($second = null)
    {
        // validation for constraint: string
        if (!is_null($second) && !is_string($second)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($second)), __LINE__);
        }
        if (is_null($second) || (is_array($second) && empty($second))) {
            unset($this->Second);
        } else {
            $this->Second = $second;
        }
        return $this;
    }
    /**
     * Get Ferry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFerry()
    {
        return isset($this->Ferry) ? $this->Ferry : null;
    }
    /**
     * Set Ferry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ferry
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setFerry($ferry = null)
    {
        // validation for constraint: string
        if (!is_null($ferry) && !is_string($ferry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ferry)), __LINE__);
        }
        if (is_null($ferry) || (is_array($ferry) && empty($ferry))) {
            unset($this->Ferry);
        } else {
            $this->Ferry = $ferry;
        }
        return $this;
    }
    /**
     * Get Ramp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRamp()
    {
        return isset($this->Ramp) ? $this->Ramp : null;
    }
    /**
     * Set Ramp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ramp
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setRamp($ramp = null)
    {
        // validation for constraint: string
        if (!is_null($ramp) && !is_string($ramp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ramp)), __LINE__);
        }
        if (is_null($ramp) || (is_array($ramp) && empty($ramp))) {
            unset($this->Ramp);
        } else {
            $this->Ramp = $ramp;
        }
        return $this;
    }
    /**
     * Get Local value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLocal()
    {
        return isset($this->Local) ? $this->Local : null;
    }
    /**
     * Set Local value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $local
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setLocal($local = null)
    {
        // validation for constraint: string
        if (!is_null($local) && !is_string($local)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($local)), __LINE__);
        }
        if (is_null($local) || (is_array($local) && empty($local))) {
            unset($this->Local);
        } else {
            $this->Local = $local;
        }
        return $this;
    }
    /**
     * Get Toll value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getToll()
    {
        return isset($this->Toll) ? $this->Toll : null;
    }
    /**
     * Set Toll value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $toll
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setToll($toll = null)
    {
        // validation for constraint: string
        if (!is_null($toll) && !is_string($toll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($toll)), __LINE__);
        }
        if (is_null($toll) || (is_array($toll) && empty($toll))) {
            unset($this->Toll);
        } else {
            $this->Toll = $toll;
        }
        return $this;
    }
    /**
     * Get Energy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEnergy()
    {
        return isset($this->Energy) ? $this->Energy : null;
    }
    /**
     * Set Energy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $energy
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public function setEnergy($energy = null)
    {
        // validation for constraint: string
        if (!is_null($energy) && !is_string($energy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($energy)), __LINE__);
        }
        if (is_null($energy) || (is_array($energy) && empty($energy))) {
            unset($this->Energy);
        } else {
            $this->Energy = $energy;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmRoadReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
