<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StateCountry StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:StateCountry
 * @package Pcm
 * @subpackage Structs
 */
class PcmStateCountry extends AbstractStructBase
{
    /**
     * The StateAbbr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StateAbbr;
    /**
     * The StateName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StateName;
    /**
     * The CountryAbbr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryAbbr;
    /**
     * The CountryName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryName;
    /**
     * Constructor method for StateCountry
     * @uses PcmStateCountry::setStateAbbr()
     * @uses PcmStateCountry::setStateName()
     * @uses PcmStateCountry::setCountryAbbr()
     * @uses PcmStateCountry::setCountryName()
     * @param string $stateAbbr
     * @param string $stateName
     * @param string $countryAbbr
     * @param string $countryName
     */
    public function __construct($stateAbbr = null, $stateName = null, $countryAbbr = null, $countryName = null)
    {
        $this
            ->setStateAbbr($stateAbbr)
            ->setStateName($stateName)
            ->setCountryAbbr($countryAbbr)
            ->setCountryName($countryName);
    }
    /**
     * Get StateAbbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStateAbbr()
    {
        return isset($this->StateAbbr) ? $this->StateAbbr : null;
    }
    /**
     * Set StateAbbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stateAbbr
     * @return \Pcm\StructType\PcmStateCountry
     */
    public function setStateAbbr($stateAbbr = null)
    {
        // validation for constraint: string
        if (!is_null($stateAbbr) && !is_string($stateAbbr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stateAbbr)), __LINE__);
        }
        if (is_null($stateAbbr) || (is_array($stateAbbr) && empty($stateAbbr))) {
            unset($this->StateAbbr);
        } else {
            $this->StateAbbr = $stateAbbr;
        }
        return $this;
    }
    /**
     * Get StateName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStateName()
    {
        return isset($this->StateName) ? $this->StateName : null;
    }
    /**
     * Set StateName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stateName
     * @return \Pcm\StructType\PcmStateCountry
     */
    public function setStateName($stateName = null)
    {
        // validation for constraint: string
        if (!is_null($stateName) && !is_string($stateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stateName)), __LINE__);
        }
        if (is_null($stateName) || (is_array($stateName) && empty($stateName))) {
            unset($this->StateName);
        } else {
            $this->StateName = $stateName;
        }
        return $this;
    }
    /**
     * Get CountryAbbr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryAbbr()
    {
        return isset($this->CountryAbbr) ? $this->CountryAbbr : null;
    }
    /**
     * Set CountryAbbr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryAbbr
     * @return \Pcm\StructType\PcmStateCountry
     */
    public function setCountryAbbr($countryAbbr = null)
    {
        // validation for constraint: string
        if (!is_null($countryAbbr) && !is_string($countryAbbr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($countryAbbr)), __LINE__);
        }
        if (is_null($countryAbbr) || (is_array($countryAbbr) && empty($countryAbbr))) {
            unset($this->CountryAbbr);
        } else {
            $this->CountryAbbr = $countryAbbr;
        }
        return $this;
    }
    /**
     * Get CountryName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryName()
    {
        return isset($this->CountryName) ? $this->CountryName : null;
    }
    /**
     * Set CountryName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryName
     * @return \Pcm\StructType\PcmStateCountry
     */
    public function setCountryName($countryName = null)
    {
        // validation for constraint: string
        if (!is_null($countryName) && !is_string($countryName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($countryName)), __LINE__);
        }
        if (is_null($countryName) || (is_array($countryName) && empty($countryName))) {
            unset($this->CountryName);
        } else {
            $this->CountryName = $countryName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmStateCountry
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
