<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WeatherAlertEvent StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WeatherAlertEvent
 * @package Pcm
 * @subpackage Structs
 */
class PcmWeatherAlertEvent extends AbstractStructBase
{
    /**
     * The AlertEvent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AlertEvent;
    /**
     * The AreaDesc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AreaDesc;
    /**
     * The Certainty
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Certainty;
    /**
     * The CountryCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryCode;
    /**
     * The DispEffective
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DispEffective;
    /**
     * The DispExpires
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DispExpires;
    /**
     * The DispPublished
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DispPublished;
    /**
     * The DispUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DispUpdated;
    /**
     * The Effective
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Effective;
    /**
     * The Expires
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Expires;
    /**
     * The FipsCodes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FipsCodes;
    /**
     * The LanguageCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LanguageCode;
    /**
     * The Polygon
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Polygon;
    /**
     * The Published
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Published;
    /**
     * The Severity
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Severity;
    /**
     * The Summary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Summary;
    /**
     * The Title
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Title;
    /**
     * The Updated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Updated;
    /**
     * The Urgency
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Urgency;
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ID;
    /**
     * Constructor method for WeatherAlertEvent
     * @uses PcmWeatherAlertEvent::setAlertEvent()
     * @uses PcmWeatherAlertEvent::setAreaDesc()
     * @uses PcmWeatherAlertEvent::setCertainty()
     * @uses PcmWeatherAlertEvent::setCountryCode()
     * @uses PcmWeatherAlertEvent::setDispEffective()
     * @uses PcmWeatherAlertEvent::setDispExpires()
     * @uses PcmWeatherAlertEvent::setDispPublished()
     * @uses PcmWeatherAlertEvent::setDispUpdated()
     * @uses PcmWeatherAlertEvent::setEffective()
     * @uses PcmWeatherAlertEvent::setExpires()
     * @uses PcmWeatherAlertEvent::setFipsCodes()
     * @uses PcmWeatherAlertEvent::setLanguageCode()
     * @uses PcmWeatherAlertEvent::setPolygon()
     * @uses PcmWeatherAlertEvent::setPublished()
     * @uses PcmWeatherAlertEvent::setSeverity()
     * @uses PcmWeatherAlertEvent::setSummary()
     * @uses PcmWeatherAlertEvent::setTitle()
     * @uses PcmWeatherAlertEvent::setUpdated()
     * @uses PcmWeatherAlertEvent::setUrgency()
     * @uses PcmWeatherAlertEvent::setID()
     * @param string $alertEvent
     * @param string $areaDesc
     * @param string $certainty
     * @param string $countryCode
     * @param string $dispEffective
     * @param string $dispExpires
     * @param string $dispPublished
     * @param string $dispUpdated
     * @param string $effective
     * @param string $expires
     * @param string $fipsCodes
     * @param string $languageCode
     * @param string $polygon
     * @param string $published
     * @param string $severity
     * @param string $summary
     * @param string $title
     * @param string $updated
     * @param string $urgency
     * @param string $iD
     */
    public function __construct($alertEvent = null, $areaDesc = null, $certainty = null, $countryCode = null, $dispEffective = null, $dispExpires = null, $dispPublished = null, $dispUpdated = null, $effective = null, $expires = null, $fipsCodes = null, $languageCode = null, $polygon = null, $published = null, $severity = null, $summary = null, $title = null, $updated = null, $urgency = null, $iD = null)
    {
        $this
            ->setAlertEvent($alertEvent)
            ->setAreaDesc($areaDesc)
            ->setCertainty($certainty)
            ->setCountryCode($countryCode)
            ->setDispEffective($dispEffective)
            ->setDispExpires($dispExpires)
            ->setDispPublished($dispPublished)
            ->setDispUpdated($dispUpdated)
            ->setEffective($effective)
            ->setExpires($expires)
            ->setFipsCodes($fipsCodes)
            ->setLanguageCode($languageCode)
            ->setPolygon($polygon)
            ->setPublished($published)
            ->setSeverity($severity)
            ->setSummary($summary)
            ->setTitle($title)
            ->setUpdated($updated)
            ->setUrgency($urgency)
            ->setID($iD);
    }
    /**
     * Get AlertEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAlertEvent()
    {
        return isset($this->AlertEvent) ? $this->AlertEvent : null;
    }
    /**
     * Set AlertEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $alertEvent
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setAlertEvent($alertEvent = null)
    {
        // validation for constraint: string
        if (!is_null($alertEvent) && !is_string($alertEvent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alertEvent)), __LINE__);
        }
        if (is_null($alertEvent) || (is_array($alertEvent) && empty($alertEvent))) {
            unset($this->AlertEvent);
        } else {
            $this->AlertEvent = $alertEvent;
        }
        return $this;
    }
    /**
     * Get AreaDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAreaDesc()
    {
        return isset($this->AreaDesc) ? $this->AreaDesc : null;
    }
    /**
     * Set AreaDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $areaDesc
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setAreaDesc($areaDesc = null)
    {
        // validation for constraint: string
        if (!is_null($areaDesc) && !is_string($areaDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($areaDesc)), __LINE__);
        }
        if (is_null($areaDesc) || (is_array($areaDesc) && empty($areaDesc))) {
            unset($this->AreaDesc);
        } else {
            $this->AreaDesc = $areaDesc;
        }
        return $this;
    }
    /**
     * Get Certainty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCertainty()
    {
        return isset($this->Certainty) ? $this->Certainty : null;
    }
    /**
     * Set Certainty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $certainty
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setCertainty($certainty = null)
    {
        // validation for constraint: string
        if (!is_null($certainty) && !is_string($certainty)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($certainty)), __LINE__);
        }
        if (is_null($certainty) || (is_array($certainty) && empty($certainty))) {
            unset($this->Certainty);
        } else {
            $this->Certainty = $certainty;
        }
        return $this;
    }
    /**
     * Get CountryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryCode()
    {
        return isset($this->CountryCode) ? $this->CountryCode : null;
    }
    /**
     * Set CountryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryCode
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($countryCode)), __LINE__);
        }
        if (is_null($countryCode) || (is_array($countryCode) && empty($countryCode))) {
            unset($this->CountryCode);
        } else {
            $this->CountryCode = $countryCode;
        }
        return $this;
    }
    /**
     * Get DispEffective value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDispEffective()
    {
        return isset($this->DispEffective) ? $this->DispEffective : null;
    }
    /**
     * Set DispEffective value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dispEffective
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setDispEffective($dispEffective = null)
    {
        // validation for constraint: string
        if (!is_null($dispEffective) && !is_string($dispEffective)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dispEffective)), __LINE__);
        }
        if (is_null($dispEffective) || (is_array($dispEffective) && empty($dispEffective))) {
            unset($this->DispEffective);
        } else {
            $this->DispEffective = $dispEffective;
        }
        return $this;
    }
    /**
     * Get DispExpires value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDispExpires()
    {
        return isset($this->DispExpires) ? $this->DispExpires : null;
    }
    /**
     * Set DispExpires value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dispExpires
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setDispExpires($dispExpires = null)
    {
        // validation for constraint: string
        if (!is_null($dispExpires) && !is_string($dispExpires)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dispExpires)), __LINE__);
        }
        if (is_null($dispExpires) || (is_array($dispExpires) && empty($dispExpires))) {
            unset($this->DispExpires);
        } else {
            $this->DispExpires = $dispExpires;
        }
        return $this;
    }
    /**
     * Get DispPublished value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDispPublished()
    {
        return isset($this->DispPublished) ? $this->DispPublished : null;
    }
    /**
     * Set DispPublished value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dispPublished
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setDispPublished($dispPublished = null)
    {
        // validation for constraint: string
        if (!is_null($dispPublished) && !is_string($dispPublished)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dispPublished)), __LINE__);
        }
        if (is_null($dispPublished) || (is_array($dispPublished) && empty($dispPublished))) {
            unset($this->DispPublished);
        } else {
            $this->DispPublished = $dispPublished;
        }
        return $this;
    }
    /**
     * Get DispUpdated value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDispUpdated()
    {
        return isset($this->DispUpdated) ? $this->DispUpdated : null;
    }
    /**
     * Set DispUpdated value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dispUpdated
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setDispUpdated($dispUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($dispUpdated) && !is_string($dispUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dispUpdated)), __LINE__);
        }
        if (is_null($dispUpdated) || (is_array($dispUpdated) && empty($dispUpdated))) {
            unset($this->DispUpdated);
        } else {
            $this->DispUpdated = $dispUpdated;
        }
        return $this;
    }
    /**
     * Get Effective value
     * @return string|null
     */
    public function getEffective()
    {
        return $this->Effective;
    }
    /**
     * Set Effective value
     * @param string $effective
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setEffective($effective = null)
    {
        // validation for constraint: string
        if (!is_null($effective) && !is_string($effective)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($effective)), __LINE__);
        }
        $this->Effective = $effective;
        return $this;
    }
    /**
     * Get Expires value
     * @return string|null
     */
    public function getExpires()
    {
        return $this->Expires;
    }
    /**
     * Set Expires value
     * @param string $expires
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setExpires($expires = null)
    {
        // validation for constraint: string
        if (!is_null($expires) && !is_string($expires)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expires)), __LINE__);
        }
        $this->Expires = $expires;
        return $this;
    }
    /**
     * Get FipsCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFipsCodes()
    {
        return isset($this->FipsCodes) ? $this->FipsCodes : null;
    }
    /**
     * Set FipsCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fipsCodes
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setFipsCodes($fipsCodes = null)
    {
        // validation for constraint: string
        if (!is_null($fipsCodes) && !is_string($fipsCodes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fipsCodes)), __LINE__);
        }
        if (is_null($fipsCodes) || (is_array($fipsCodes) && empty($fipsCodes))) {
            unset($this->FipsCodes);
        } else {
            $this->FipsCodes = $fipsCodes;
        }
        return $this;
    }
    /**
     * Get LanguageCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLanguageCode()
    {
        return isset($this->LanguageCode) ? $this->LanguageCode : null;
    }
    /**
     * Set LanguageCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $languageCode
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setLanguageCode($languageCode = null)
    {
        // validation for constraint: string
        if (!is_null($languageCode) && !is_string($languageCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($languageCode)), __LINE__);
        }
        if (is_null($languageCode) || (is_array($languageCode) && empty($languageCode))) {
            unset($this->LanguageCode);
        } else {
            $this->LanguageCode = $languageCode;
        }
        return $this;
    }
    /**
     * Get Polygon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPolygon()
    {
        return isset($this->Polygon) ? $this->Polygon : null;
    }
    /**
     * Set Polygon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $polygon
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setPolygon($polygon = null)
    {
        // validation for constraint: string
        if (!is_null($polygon) && !is_string($polygon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($polygon)), __LINE__);
        }
        if (is_null($polygon) || (is_array($polygon) && empty($polygon))) {
            unset($this->Polygon);
        } else {
            $this->Polygon = $polygon;
        }
        return $this;
    }
    /**
     * Get Published value
     * @return string|null
     */
    public function getPublished()
    {
        return $this->Published;
    }
    /**
     * Set Published value
     * @param string $published
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setPublished($published = null)
    {
        // validation for constraint: string
        if (!is_null($published) && !is_string($published)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($published)), __LINE__);
        }
        $this->Published = $published;
        return $this;
    }
    /**
     * Get Severity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeverity()
    {
        return isset($this->Severity) ? $this->Severity : null;
    }
    /**
     * Set Severity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $severity
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setSeverity($severity = null)
    {
        // validation for constraint: string
        if (!is_null($severity) && !is_string($severity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($severity)), __LINE__);
        }
        if (is_null($severity) || (is_array($severity) && empty($severity))) {
            unset($this->Severity);
        } else {
            $this->Severity = $severity;
        }
        return $this;
    }
    /**
     * Get Summary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSummary()
    {
        return isset($this->Summary) ? $this->Summary : null;
    }
    /**
     * Set Summary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $summary
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setSummary($summary = null)
    {
        // validation for constraint: string
        if (!is_null($summary) && !is_string($summary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($summary)), __LINE__);
        }
        if (is_null($summary) || (is_array($summary) && empty($summary))) {
            unset($this->Summary);
        } else {
            $this->Summary = $summary;
        }
        return $this;
    }
    /**
     * Get Title value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitle()
    {
        return isset($this->Title) ? $this->Title : null;
    }
    /**
     * Set Title value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $title
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($title)), __LINE__);
        }
        if (is_null($title) || (is_array($title) && empty($title))) {
            unset($this->Title);
        } else {
            $this->Title = $title;
        }
        return $this;
    }
    /**
     * Get Updated value
     * @return string|null
     */
    public function getUpdated()
    {
        return $this->Updated;
    }
    /**
     * Set Updated value
     * @param string $updated
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setUpdated($updated = null)
    {
        // validation for constraint: string
        if (!is_null($updated) && !is_string($updated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($updated)), __LINE__);
        }
        $this->Updated = $updated;
        return $this;
    }
    /**
     * Get Urgency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrgency()
    {
        return isset($this->Urgency) ? $this->Urgency : null;
    }
    /**
     * Set Urgency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urgency
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setUrgency($urgency = null)
    {
        // validation for constraint: string
        if (!is_null($urgency) && !is_string($urgency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($urgency)), __LINE__);
        }
        if (is_null($urgency) || (is_array($urgency) && empty($urgency))) {
            unset($this->Urgency);
        } else {
            $this->Urgency = $urgency;
        }
        return $this;
    }
    /**
     * Get ID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getID()
    {
        return isset($this->ID) ? $this->ID : null;
    }
    /**
     * Set ID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iD
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iD)), __LINE__);
        }
        if (is_null($iD) || (is_array($iD) && empty($iD))) {
            unset($this->ID);
        } else {
            $this->ID = $iD;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmWeatherAlertEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
